#!/usr/bin/python

"""
This is a "fake" SNMP module so that people can try out the SMI module
without having the whole SNMP package. It simple defines the one object
that the SMI module imports.

"""

import sys, os


# This object is the interface to the pysmi module. The SMI module
# instantiates these from the MIB oid. This can be passed to the SNMP
# Session.set() method. However, the SNMP object model really makes this
# unnecessary.
class OID(UserList):
	def __init__(self, oid=None):
		if not oid:
			self.data = []
		elif type(oid) is StringType:
			self.data = ber.str2nums(oid)
		elif type(oid) is ListType:
			self.data = oid
		elif isinstance(oid, UserList):
			self.data = oid.data
		else:
			raise ValueErorr, "OID must be initialized with OID string, list or another instance"
	def __str__(self):
		return ber.nums2str(self.data)
	def __repr__(self):
		return "%s(%s)" % (self.__class__.__name__, repr(self.data))
	def __cmp__(self, other):
# Until python 2.1...
		# self can only be greater than other if prefixes match.
		len_self = len(self) ; len_other = len(other)
		cv = cmp(len(self), len(other))
		if cv < 0: # then self is shorter than other, defined as less
			return -1
		elif cv == 0: # then self is same size as other
			if self.data == other.data:
				return 0
			else:
				return -1
		else: # then self is longer than other
			if self.data[:len(other.data)] == other.data:
				return 1
			else:
				return -1

	# subtracting one oid from another removes any common prefix
	# (considered to be the difference).
	def __sub__(self, other):
		if isinstance(other, UserList):
			l = other.data
		elif isinstance(other, type(self.data)):
			l = other
		else:
			l = list(other)
		for i in range(min(len(self.data), len(l))):
			if self.data[i] != other.data[i]:
				return self.__class__(self.data[i:])



